#include "xyza2pipe.h"

static float filesize;

static void cnvhdr2d(const char axis_option, const char fb, const int size, const int x, const int y);
static void cnvhdr3d(const char axis_option, const char fb, const int size, const int x, const int y, const int z);
static void cnvhdr4d(const char axis_option, const char fb, const int size, const int x, const int y, const int z,
    const int a);

void cnvhdr(const char axis_option, const char fb)
{
 switch (dimension) {
 case 2:
  cnvhdr2d(axis_option, fb, sizeof(float), 96, 100);
  cnvhdr2d(axis_option, fb, sizeof(float), 396, 876);
  break;

 case 3:
  cnvhdr3d(axis_option, fb, sizeof(float), 96, 100, 104);
  cnvhdr3d(axis_option, fb, sizeof(float), 396, 876, 60);
  break;

 case 4:
  cnvhdr4d(axis_option, fb, sizeof(float), 96, 100, 104, 108);
  cnvhdr4d(axis_option, fb, sizeof(float), 396, 876, 60, 128);
  break;
 }

 fwrite2mem(header + 1768, filesize);
}

static void cnvhdr2d(const char axis_option, const char fb, const int size, const int x, const int y)
{
 int l;

 filesize = 1.0;

 switch (axis_option) {

 case 'x':
  break;

 case 'y':
  for (l = 0; l < PIPE_HEADERSIZE; l++)
   _header_[l] = header[l];

  if (fb == 'f' || fb == 'b') {
   for (l = 0; l < size; l++) {
    header[x + l] = _header_[y + l];
    header[y + l] = _header_[x + l];
   }
  }

  break;
 }
}

static void cnvhdr3d(const char axis_option, const char fb, const int size, const int x, const int y, const int z)
{
 int l;

 switch (axis_option) {

 case 'x':
  filesize = datasize[2];
  break;

 case 'y':
  for (l = 0; l < PIPE_HEADERSIZE; l++)
   _header_[l] = header[l];

  if (fb == 'f' || fb == 'b') {
   for (l = 0; l < size; l++) {
    header[x + l] = _header_[y + l];
    header[y + l] = _header_[x + l];
    header[z + l] = _header_[z + l];
   }

   filesize = datasize[2];
  }

  break;

 case 'z':
  for (l = 0; l < PIPE_HEADERSIZE; l++)
   _header_[l] = header[l];

  if (fb == 'f') {
   for (l = 0; l < size; l++) {
    header[x + l] = _header_[z + l];
    header[y + l] = _header_[x + l];
    header[z + l] = _header_[y + l];
   }

   filesize = datasize[1];
  }

  if (fb == 'b') {
   for (l = 0; l < size; l++) {
    header[x + l] = _header_[y + l];
    header[y + l] = _header_[z + l];
    header[z + l] = _header_[x + l];
   }

   filesize = datasize[0];
  }

  break;
 }
}

static void cnvhdr4d(const char axis_option, const char fb, const int size, const int x, const int y, const int z,
    const int a)
{
 int l;

 switch (axis_option) {

 case 'x':
  filesize = datasize[2] * datasize[3];
  break;

 case 'y':
  for (l = 0; l < PIPE_HEADERSIZE; l++)
   _header_[l] = header[l];

  if (fb == 'f' || fb == 'b') {
   for (l = 0; l < size; l++) {
    header[x + l] = _header_[y + l];
    header[y + l] = _header_[x + l];
    header[z + l] = _header_[z + l];
    header[a + l] = _header_[a + l];
   }
   filesize = datasize[2] * datasize[3];
  }

  break;

 case 'z':
  for (l = 0; l < PIPE_HEADERSIZE; l++)
   _header_[l] = header[l];

  if (fb == 'f') {
   for (l = 0; l < size; l++) {
    header[x + l] = _header_[z + l];
    header[y + l] = _header_[x + l];
    header[z + l] = _header_[y + l];
    header[a + l] = _header_[a + l];
   }

   filesize = datasize[1] * datasize[3];
  }

  if (fb == 'b') {
   for (l = 0; l < size; l++) {
    header[x + l] = _header_[y + l];
    header[y + l] = _header_[z + l];
    header[z + l] = _header_[x + l];
    header[a + l] = _header_[a + l];
   }

   filesize = datasize[0] * datasize[3];
  }

  break;

 case 'a':
  for (l = 0; l < PIPE_HEADERSIZE; l++)
   _header_[l] = header[l];

  if (fb == 'f') {
   for (l = 0; l < size; l++) {
    header[x + l] = _header_[a + l];
    header[y + l] = _header_[x + l];
    header[z + l] = _header_[y + l];
    header[a + l] = _header_[z + l];
   }

   filesize = datasize[1] * datasize[2];
  }

  if (fb == 'b') {
   for (l = 0; l < size; l++) {
    header[x + l] = _header_[y + l];
    header[y + l] = _header_[z + l];
    header[z + l] = _header_[a + l];
    header[a + l] = _header_[x + l];
   }

   filesize = datasize[0] * datasize[3];
  }

  break;
 }
}
