#include "xyza2pipe.h"

int pullxyza2d(char spectra2d[], const char axis_option)
{
 FILE *fp;
 int i, j, k, count = 0, axisorder[4], orderaxis[4];
 float *vp;

 makedir(spectra2d);

 vp = (float *) ((void *) (&header[96]));
 if (*vp == 2.0)
  axisorder[0] = 0;
 if (*vp == 1.0)
  axisorder[0] = 1;
 if (*vp == 3.0)
  axisorder[0] = 2;
 if (*vp == 4.0)
  axisorder[0] = 3;

 vp = (float *) ((void *) (&header[100]));
 if (*vp == 2.0)
  axisorder[1] = 0;
 if (*vp == 1.0)
  axisorder[1] = 1;
 if (*vp == 3.0)
  axisorder[1] = 2;
 if (*vp == 4.0)
  axisorder[1] = 3;

 vp = (float *) ((void *) (&header[104]));
 if (*vp == 2.0)
  axisorder[2] = 0;
 if (*vp == 1.0)
  axisorder[2] = 1;
 if (*vp == 3.0)
  axisorder[2] = 2;
 if (*vp == 4.0)
  axisorder[2] = 3;

 vp = (float *) ((void *) (&header[108]));
 if (*vp == 2.0)
  axisorder[3] = 0;
 if (*vp == 1.0)
  axisorder[3] = 1;
 if (*vp == 3.0)
  axisorder[3] = 2;
 if (*vp == 4.0)
  axisorder[3] = 3;

 for (j = 0; j < 4; j++) {
  for (k = 0; k < 4; k++) {
   if (axisorder[k] == j)
    orderaxis[j] = k;
  }
 }

 if (orderaxis[0] == 0)
  fwrite2mem(header + 264, spcenter[0] + leftcar * spwidth[0] / 2.0 / obsfreq[0]);
 else if (orderaxis[1] == 0)
  fwrite2mem(header + 268, spcenter[0] + leftcar * spwidth[0] / 2.0 / obsfreq[0]);

 matrix2d = fmalloc2d(datasize[1], datasize[0]);

 switch (axis_option) {
 case 'x':
  fprintf(stderr, "                                      " "                                      \r");
  fprintf(stderr, "Receiving %d of %d ( -> pipe2xyza) ...\r", ++count, 1);

  if (openpipe2d(matrix2d) != 0)
   goto escape;

  if ((fp = fopen(spectra2d, "w")) == NULL) {
   fprintf(stderr, "Permission denied to write %s.\n", spectra2d);
   exit(EXIT_FAILURE);
  }

  fprintf(stderr, "                                      " "                                      \r");
  fprintf(stderr, "Writing %s <- pipe2xyza ...\r", spectra2d);

  fwrite(header, sizeof(char), PIPE_HEADERSIZE, fp);

  fpwrite2bin_swap(fp, &(matrix2d[0][0]), datasize[1] * datasize[0], swapdata);

  fclose(fp);

  break;

 case 'y':
  fprintf(stderr, "                                      " "                                      \r");
  fprintf(stderr, "Receiving %d of %d ( -> pipe2xyza) ...\r", ++count, 1);

  if (openpipe2d(matrix2d) != 0)
   goto escape;

  if ((fp = fopen(spectra2d, "w")) == NULL) {
   fprintf(stderr, "Permission denied to write %s.\n", spectra2d);
   exit(EXIT_FAILURE);
  }

  fprintf(stderr, "                                      " "                                      \r");
  fprintf(stderr, "Writing %s <- pipe2xyza ...\r", spectra2d);

  fwrite(header, sizeof(char), PIPE_HEADERSIZE, fp);

  for (i = 0; i < datasize[0]; i++) {
   for (j = 0; j < datasize[1]; j++) {
    fpwrite2bin_swap(fp, &(matrix2d[j][i]), 1, swapdata);
   }
  }

  fclose(fp);

  break;
 }

 free_fmatrix2d(matrix2d);

 fputc('\n', stderr);

 return 0;

escape:free_fmatrix2d(matrix2d);

 return 1;
}

int pullxyza3d(char spectra3d[], const char axis_option)
{
 FILE *fp;
 char filename[MAXLONGNAME];
 int i, j, k, count = 0, axisorder[4], orderaxis[4];
 float *vp, ***matrix3d_;

 makedir(spectra3d);

 vp = (float *) ((void *) (&header[96]));
 if (*vp == 2.0)
  axisorder[0] = 0;
 if (*vp == 1.0)
  axisorder[0] = 1;
 if (*vp == 3.0)
  axisorder[0] = 2;
 if (*vp == 4.0)
  axisorder[0] = 3;

 vp = (float *) ((void *) (&header[100]));
 if (*vp == 2.0)
  axisorder[1] = 0;
 if (*vp == 1.0)
  axisorder[1] = 1;
 if (*vp == 3.0)
  axisorder[1] = 2;
 if (*vp == 4.0)
  axisorder[1] = 3;

 vp = (float *) ((void *) (&header[104]));
 if (*vp == 2.0)
  axisorder[2] = 0;
 if (*vp == 1.0)
  axisorder[2] = 1;
 if (*vp == 3.0)
  axisorder[2] = 2;
 if (*vp == 4.0)
  axisorder[2] = 3;

 vp = (float *) ((void *) (&header[108]));
 if (*vp == 2.0)
  axisorder[3] = 0;
 if (*vp == 1.0)
  axisorder[3] = 1;
 if (*vp == 3.0)
  axisorder[3] = 2;
 if (*vp == 4.0)
  axisorder[3] = 3;

 for (j = 0; j < 4; j++) {
  for (k = 0; k < 4; k++) {
   if (axisorder[k] == j)
    orderaxis[j] = k;
  }
 }

 if (orderaxis[0] == 0)
  fwrite2mem(header + 264, spcenter[0] + leftcar * spwidth[0] / 2.0 / obsfreq[0]);
 else if (orderaxis[1] == 0)
  fwrite2mem(header + 268, spcenter[0] + leftcar * spwidth[0] / 2.0 / obsfreq[0]);
 else if (orderaxis[2] == 0)
  fwrite2mem(header + 272, spcenter[0] + leftcar * spwidth[0] / 2.0 / obsfreq[0]);

 matrix2d = fmalloc2d(datasize[1], datasize[0]);

 switch (axis_option) {
 case 'x':
 case 'a':
  for (k = 0; k < datasize[2]; k++) {
   fprintf(stderr, "                                      " "                                      \r");
   fprintf(stderr, "Receiving %d of %d ( -> pipe2xyza) ...\r", ++count, datasize[2]);

   if (openpipe2d(matrix2d) != 0)
    goto escape;

   sprintf(filename, spectra3d, k + 1);

   if ((fp = fopen(filename, "w")) == NULL) {
    fprintf(stderr, "Permission denied to write %s.\n", filename);
    exit(EXIT_FAILURE);
   }

   fprintf(stderr, "                                      " "                                      \r");
   fprintf(stderr, "Writing %s <- pipe2xyza ...\r", filename);

   fwrite(header, sizeof(char), PIPE_HEADERSIZE, fp);

   fpwrite2bin_swap(fp, &(matrix2d[0][0]), datasize[1] * datasize[0], swapdata);

   fclose(fp);
  }

  break;

 case 'y':
  for (k = 0; k < datasize[2]; k++) {
   fprintf(stderr, "                                      " "                                      \r");
   fprintf(stderr, "Receiving %d of %d ( -> pipe2xyza) ...\r", ++count, datasize[2]);

   if (openpipe2d(matrix2d) != 0)
    goto escape;

   sprintf(filename, spectra3d, k + 1);

   if ((fp = fopen(filename, "w")) == NULL) {
    fprintf(stderr, "Permission denied to write %s.\n", filename);
    exit(EXIT_FAILURE);
   }

   fprintf(stderr, "                                      " "                                      \r");
   fprintf(stderr, "Writing %s <- pipe2xyza ...\r", filename);

   fwrite(header, sizeof(char), PIPE_HEADERSIZE, fp);

   for (i = 0; i < datasize[0]; i++) {
    for (j = 0; j < datasize[1]; j++) {
     fpwrite2bin_swap(fp, &(matrix2d[j][i]), 1, swapdata);
    }
   }

   fclose(fp);
  }

  break;

 case 'z':
  matrix3d_ = fmalloc3d(datasize[0], datasize[2], datasize[1]);

  for (k = 0; k < datasize[2]; k++) {
   fprintf(stderr, "                                      " "                                      \r");
   fprintf(stderr, "Receiving %d of %d ( -> pipe2xyza) ...\r", ++count, datasize[2]);

   if (openpipe2d(matrix2d) != 0)
    goto escape2;

   for (i = 0; i < datasize[0]; i++) {
    for (j = 0; j < datasize[1]; j++) {
     matrix3d_[i][k][j] = matrix2d[j][i];
    }
   }
  }

  for (i = 0; i < datasize[0]; i++) {

   sprintf(filename, spectra3d, i + 1);

   if ((fp = fopen(filename, "w")) == NULL) {
    fprintf(stderr, "Permission denied to write %s.\n", filename);
    exit(EXIT_FAILURE);
   }

   fprintf(stderr, "                                      " "                                      \r");
   fprintf(stderr, "Writing %s <- pipe2xyza ...\r", filename);

   fwrite(header, sizeof(char), PIPE_HEADERSIZE, fp);

   fpwrite2bin_swap(fp, &(matrix3d_[i][0][0]), datasize[2] * datasize[1], swapdata);

   fclose(fp);
  }

  free_fmatrix3d(matrix3d_);

  break;
 }

 free_fmatrix2d(matrix2d);

 fputc('\n', stderr);

 return 0;

escape2:free_fmatrix3d(matrix3d_);

escape:free_fmatrix2d(matrix2d);

 return 1;
}

int pullxyza4d(char spectra4d[], const char axis_option)
{
 FILE *fp;
 char filename[MAXLONGNAME];
 int i, j, k, l, count = 0, axisorder[4], orderaxis[4];
 float *vp, ***matrix3d_;

 makedir(spectra4d);

 vp = (float *) ((void *) (&header[96]));
 if (*vp == 2.0)
  axisorder[0] = 0;
 if (*vp == 1.0)
  axisorder[0] = 1;
 if (*vp == 3.0)
  axisorder[0] = 2;
 if (*vp == 4.0)
  axisorder[0] = 3;

 vp = (float *) ((void *) (&header[100]));
 if (*vp == 2.0)
  axisorder[1] = 0;
 if (*vp == 1.0)
  axisorder[1] = 1;
 if (*vp == 3.0)
  axisorder[1] = 2;
 if (*vp == 4.0)
  axisorder[1] = 3;

 vp = (float *) ((void *) (&header[104]));
 if (*vp == 2.0)
  axisorder[2] = 0;
 if (*vp == 1.0)
  axisorder[2] = 1;
 if (*vp == 3.0)
  axisorder[2] = 2;
 if (*vp == 4.0)
  axisorder[2] = 3;

 vp = (float *) ((void *) (&header[108]));
 if (*vp == 2.0)
  axisorder[3] = 0;
 if (*vp == 1.0)
  axisorder[3] = 1;
 if (*vp == 3.0)
  axisorder[3] = 2;
 if (*vp == 4.0)
  axisorder[3] = 3;

 for (j = 0; j < 4; j++) {
  for (k = 0; k < 4; k++) {
   if (axisorder[k] == j)
    orderaxis[j] = k;
  }
 }

 if (orderaxis[0] == 0)
  fwrite2mem(header + 264, spcenter[0] + leftcar * spwidth[0] / 2.0 / obsfreq[0]);
 else if (orderaxis[1] == 0)
  fwrite2mem(header + 268, spcenter[0] + leftcar * spwidth[0] / 2.0 / obsfreq[0]);
 else if (orderaxis[2] == 0)
  fwrite2mem(header + 272, spcenter[0] + leftcar * spwidth[0] / 2.0 / obsfreq[0]);
 else if (orderaxis[3] == 0)
  fwrite2mem(header + 276, spcenter[0] + leftcar * spwidth[0] / 2.0 / obsfreq[0]);

 matrix2d = fmalloc2d(datasize[1], datasize[0]);

 switch (axis_option) {
 case 'x':
  for (l = 0; l < datasize[3]; l++) {
   for (k = 0; k < datasize[2]; k++) {
    fprintf(stderr, "                                      " "                                      \r");
    fprintf(stderr, "Receiving %d of %d ( -> pipe2xyza) ...\r", ++count, datasize[2] * datasize[3]);

    if (openpipe2d(matrix2d) != 0)
     goto escape;

    sprintf(filename, spectra4d, l + 1, k + 1);

    if ((fp = fopen(filename, "w")) == NULL) {
     fprintf(stderr, "Permission denied to write %s.\n", filename);
     exit(EXIT_FAILURE);
    }

    fprintf(stderr, "                                      " "                                      \r");
    fprintf(stderr, "Writing %s <- pipe2xyza ...\r", filename);

    fwrite(header, sizeof(char), PIPE_HEADERSIZE, fp);

    fpwrite2bin_swap(fp, &(matrix2d[0][0]), datasize[1] * datasize[0], swapdata);

    fclose(fp);
   }
  }

  break;

 case 'y':
  for (l = 0; l < datasize[3]; l++) {
   for (k = 0; k < datasize[2]; k++) {
    fprintf(stderr, "                                      " "                                      \r");
    fprintf(stderr, "Receiving %d of %d ( -> pipe2xyza) ...\r", ++count, datasize[2] * datasize[3]);

    if (openpipe2d(matrix2d) != 0)
     goto escape;

    sprintf(filename, spectra4d, l + 1, k + 1);

    if ((fp = fopen(filename, "w")) == NULL) {
     fprintf(stderr, "Permission denied to write %s.\n", filename);
     exit(EXIT_FAILURE);
    }

    fprintf(stderr, "                                      " "                                      \r");
    fprintf(stderr, "Writing %s <- pipe2xyza ...\r", filename);

    fwrite(header, sizeof(char), PIPE_HEADERSIZE, fp);

    for (i = 0; i < datasize[0]; i++) {
     for (j = 0; j < datasize[1]; j++) {
      fpwrite2bin_swap(fp, &(matrix2d[j][i]), 1, swapdata);
     }
    }

    fclose(fp);
   }
  }

  break;

 case 'z':
  matrix3d_ = fmalloc3d(datasize[0], datasize[2], datasize[1]);

  for (l = 0; l < datasize[3]; l++) {

   for (k = 0; k < datasize[2]; k++) {
    fprintf(stderr, "                                      " "                                      \r");
    fprintf(stderr, "Receiving %d of %d ( -> pipe2xyza) ...\r", ++count, datasize[2] * datasize[3]);

    if (openpipe2d(matrix2d) != 0)
     goto escape2;

    for (i = 0; i < datasize[0]; i++) {
     for (j = 0; j < datasize[1]; j++) {
      matrix3d_[i][k][j] = matrix2d[j][i];
     }
    }
   }

   for (i = 0; i < datasize[0]; i++) {

    sprintf(filename, spectra4d, l + 1, i + 1);

    if ((fp = fopen(filename, "w")) == NULL) {
     fprintf(stderr, "Permission denied to write %s.\n", filename);
     exit(EXIT_FAILURE);
    }

    fprintf(stderr, "                                      " "                                      \r");
    fprintf(stderr, "Writing %s <- pipe2xyza ...\r", filename);

    fwrite(header, sizeof(char), PIPE_HEADERSIZE, fp);

    fpwrite2bin_swap(fp, &(matrix3d_[i][0][0]), datasize[2] * datasize[1], swapdata);

    fclose(fp);
   }
  }

  free_fmatrix3d(matrix3d_);

  break;

 case 'a':
  matrix3d_ = fmalloc3d(datasize[0], datasize[2], datasize[1]);

  for (l = 0; l < datasize[3]; l++) {

   for (k = 0; k < datasize[2]; k++) {
    fprintf(stderr, "                                      " "                                      \r");
    fprintf(stderr, "Receiving %d of %d ( -> pipe2xyza) ...\r", ++count, datasize[2] * datasize[3]);

    if (openpipe2d(matrix2d) != 0)
     goto escape2;

    for (i = 0; i < datasize[0]; i++) {
     for (j = 0; j < datasize[1]; j++) {
      matrix3d_[i][k][j] = matrix2d[j][i];
     }
    }
   }

   for (i = 0; i < datasize[0]; i++) {

    sprintf(filename, spectra4d, i + 1, l + 1);

    if ((fp = fopen(filename, "w")) == NULL) {
     fprintf(stderr, "Permission denied to write %s.\n", filename);
     exit(EXIT_FAILURE);
    }

    fprintf(stderr, "                                      " "                                      \r");
    fprintf(stderr, "Writing %s <- pipe2xyza ...\r", filename);

    fwrite(header, sizeof(char), PIPE_HEADERSIZE, fp);

    fpwrite2bin_swap(fp, &(matrix3d_[i][0][0]), datasize[2] * datasize[1], swapdata);

    fclose(fp);
   }
  }

  free_fmatrix3d(matrix3d_);

  break;
 }

 free_fmatrix2d(matrix2d);

 fputc('\n', stderr);

 return 0;

escape2:free_fmatrix3d(matrix3d_);

escape:free_fmatrix2d(matrix2d);

 return 1;
}
