#include "xyza2pipe.h"

int pushnv2d(char spectra2d[], const char axis_option)
{
 int i, j;

/* HEADER */
 fwrite(header, sizeof(char), PIPE_HEADERSIZE, stdout);

 fflush(stdout);

 matrix2d = fmalloc2d(datasize[1], datasize[0]);

 if (opennv2d(spectra2d, matrix2d) != 0)
  goto escape;

 switch (axis_option) {
 case 'x':
  fpwrite2bin(stdout, &(matrix2d[0][0]), datasize[1] * datasize[0]);

  fflush(stdout);

  break;

 case 'y':
  for (i = 0; i < datasize[0]; i++) {
   for (j = 0; j < datasize[1]; j++) {
    fpwrite2bin(stdout, &(matrix2d[j][i]), 1);
   }
  }

  fflush(stdout);

  break;
 }

 free_fmatrix2d(matrix2d);

 return 0;

escape:free_fmatrix2d(matrix2d);

 return 1;
}

int pushnv3d(char spectra3d[], const char axis_option)
{
 int i, j, k;

/* HEADER */
 fwrite(header, sizeof(char), PIPE_HEADERSIZE, stdout);

 fflush(stdout);

 matrix3d = fmalloc3d(datasize[2], datasize[1], datasize[0]);

 if (opennv3d(spectra3d, matrix3d) != 0)
  goto escape;

 switch (axis_option) {
 case 'x':
  for (k = 0; k < datasize[2]; k++) {
   fpwrite2bin(stdout, &(matrix3d[k][0][0]), datasize[1] * datasize[0]);

   fflush(stdout);
  }

  break;

 case 'y':
  for (k = 0; k < datasize[2]; k++) {
   for (i = 0; i < datasize[0]; i++) {
    for (j = 0; j < datasize[1]; j++) {
     fpwrite2bin(stdout, &(matrix3d[k][j][i]), 1);
    }
   }

   fflush(stdout);
  }

  break;

 case 'z':
  for (j = 0; j < datasize[1]; j++) {
   for (i = 0; i < datasize[0]; i++) {
    for (k = 0; k < datasize[2]; k++) {
     fpwrite2bin(stdout, &(matrix3d[k][j][i]), 1);
    }
   }

   fflush(stdout);
  }

  break;
 }

 free_fmatrix3d(matrix3d);

 return 0;

escape:free_fmatrix3d(matrix3d);

 return 1;
}

int pushnv4d(char spectra4d[], const char axis_option)
{
 int i, j, k, l;

/* HEADER */
 fwrite(header, sizeof(char), PIPE_HEADERSIZE, stdout);

 fflush(stdout);

 matrix4d = fmalloc4d(datasize[3], datasize[2], datasize[1], datasize[0]);

 if (opennv4d(spectra4d, matrix4d) != 0)
  goto escape;

 switch (axis_option) {
 case 'x':
  for (l = 0; l < datasize[3]; l++) {
   for (k = 0; k < datasize[2]; k++) {
    fpwrite2bin(stdout, &(matrix4d[l][k][0][0]), datasize[1] * datasize[0]);

    fflush(stdout);
   }
  }

  break;

 case 'y':
  for (l = 0; l < datasize[3]; l++) {
   for (k = 0; k < datasize[2]; k++) {
    for (i = 0; i < datasize[0]; i++) {
     for (j = 0; j < datasize[1]; j++) {
      fpwrite2bin(stdout, &(matrix4d[l][k][j][i]), 1);
     }
    }

    fflush(stdout);
   }
  }

  break;

 case 'z':
  for (l = 0; l < datasize[3]; l++) {
   for (j = 0; j < datasize[1]; j++) {
    for (i = 0; i < datasize[0]; i++) {
     for (k = 0; k < datasize[2]; k++) {
      fpwrite2bin(stdout, &(matrix4d[l][k][j][i]), 1);
     }
    }

    fflush(stdout);
   }
  }

  break;

 case 'a':
  for (k = 0; k < datasize[2]; k++) {
   for (j = 0; j < datasize[1]; j++) {
    for (i = 0; i < datasize[0]; i++) {
     for (l = 0; l < datasize[3]; l++) {
      fpwrite2bin(stdout, &(matrix4d[l][k][j][i]), 1);
     }
    }

    fflush(stdout);
   }
  }

  break;
 }

 free_fmatrix4d(matrix4d);

 return 0;

escape:free_fmatrix4d(matrix4d);

 return 1;
}
