#include "xyza2pipe.h"

int pushvnmr2d(char spectra2d[], char pardir[], const char axis_option)
{
 int i, j;

 matrix2d = fmalloc2d(datasize[1], datasize[0]);

 if (openvnmr2d(spectra2d, pardir, matrix2d) != 0)
  goto escape;

 if (extleft) {
  datasize[0] /= 2;
  spwidth[0] /= 2.0;
  origfreq[0] += spwidth[0];
  spcenter[0] = (origfreq[0] + spwidth[0] / 2.0) / obsfreq[0];

  fwrite2mem(header + 400, spwidth[0]);
  fwrite2mem(header + 264, spcenter[0]);
  fwrite2mem(header + 404, origfreq[0]);
  fwrite2mem(header + 396, (float) (datasize[0]));
  fwrite2mem(header + 876, (float) (datasize[1]));

  cnvhdr(axis_option, 'f');
 }

 fwrite(header, sizeof(char), PIPE_HEADERSIZE, stdout);

 fflush(stdout);

 switch (axis_option) {
 case 'x':
  fpwrite2bin(stdout, &(matrix2d[0][0]), datasize[1] * datasize[0]);

  fflush(stdout);

  break;

 case 'y':
  for (i = 0; i < datasize[0]; i++) {
   for (j = 0; j < datasize[1]; j++) {
    fpwrite2bin(stdout, &(matrix2d[j][i]), 1);
   }
  }

  fflush(stdout);

  break;
 }

 free_fmatrix2d(matrix2d);

 return 0;

escape:free_fmatrix2d(matrix2d);

 return 1;
}

int pushvnmr3d(char spectra3d[], char pardir[], const char axis_option, const int nfiles, char suffix[])
{
 char string[MAXCHAR];
 int i, j, k;

 matrix3d = fmalloc3d(datasize[2], datasize[1], datasize[0]);

 if (openvnmr3d(spectra3d, pardir, nfiles, matrix3d) != 0)
  goto escape;

 sprintf(string, "rm -f monofile");
 strcat(string, suffix);
 system(string);

 if (extleft) {
  datasize[0] /= 2;
  spwidth[0] /= 2.0;
  origfreq[0] += spwidth[0];
  spcenter[0] = (origfreq[0] + spwidth[0] / 2.0) / obsfreq[0];

  fwrite2mem(header + 400, spwidth[0]);
  fwrite2mem(header + 264, spcenter[0]);
  fwrite2mem(header + 404, origfreq[0]);
  fwrite2mem(header + 396, (float) (datasize[0]));
  fwrite2mem(header + 876, (float) (datasize[1]));
  fwrite2mem(header + 60, (float) (datasize[2]));

  cnvhdr(axis_option, 'f');
 }

 fwrite(header, sizeof(char), PIPE_HEADERSIZE, stdout);

 fflush(stdout);

 switch (axis_option) {
 case 'x':
  for (k = 0; k < datasize[2]; k++) {
   fpwrite2bin(stdout, &(matrix3d[k][0][0]), datasize[1] * datasize[0]);

   fflush(stdout);
  }

  break;

 case 'y':
  for (k = 0; k < datasize[2]; k++) {
   for (i = 0; i < datasize[0]; i++) {
    for (j = 0; j < datasize[1]; j++) {
     fpwrite2bin(stdout, &(matrix3d[k][j][i]), 1);
    }
   }

   fflush(stdout);
  }

  break;

 case 'z':
  for (j = 0; j < datasize[1]; j++) {
   for (i = 0; i < datasize[0]; i++) {
    for (k = 0; k < datasize[2]; k++) {
     fpwrite2bin(stdout, &(matrix3d[k][j][i]), 1);
    }
   }

   fflush(stdout);
  }

  break;
 }

 free_fmatrix3d(matrix3d);

 return 0;

escape:free_fmatrix3d(matrix3d);

 return 1;
}
